

			    ACKNOWLEDGEMENTS

	ZMDM was derived from rz/sz for Unix  posted by 
	Chuck Forsberg (...!tektronix!reed!omen!caf ). We
	thank him for his excellent code, and for giving
	us permission to use and distribute his code and
	documentation.


	Zmdm consists of two main components:
		o The terminal emulator
		o The transfer shell
	- The terminal emulator emulates a 80*25 terminal
	(or optionally the 80*50 mode on Mono systems only).
	It uses the escape codes of the bios built in enhanced
	vt52 emulator. For UN*X users i have included the
	termcap entry that i use, that seems to work pretty
	well.
	- The transfer shell lets you send/receive files using
	Xmodem/Xmodem-CRC/Xmodem-1K/Ymodem or Zmodem protocols.
        In addition it provides UN*X csh like command for your
	convenience, and does (TOS style) wild-card handling,
        and (only single) quoting of arguments. See the accompanying
	file MODEM.DOC by Chuck Forsberg, for details of the
	above transfer protocols.

	This note describes the commands available from the
	"transfer shell". The transfer shell is a command line
	interface. In case you are wondering why i choose to
	use a command line interface, the answer is quite simple.
	The functions available have so many options and combinations
	thereof, that it would be totally impractical if not impossible
	to put them in menus/dialogues (each menu will have to be at least
	3 levels deep). Of course it is much easier to type something
	like 'sz -l 128 -L 128 *.c' than answering the atleast three
	dialogues required to pick up the same info. You enter the
	transfer shell from the terminal emulator by hitting <HELP>
	and choosing 'T' from the main menu. Once you are done using the
	transfer shell, you simply hit <RETURN> to pop back into the terminal
	emulator, exactly where you left off.
	-----
	

NAME
     rb, rz - XMODEM, YMODEM, ZMODEM (Batch) file receive

SYNOPSIS
     rz	[- pqtv]
     rb	[- pqtv]
     rz	[- cqtv] file


DESCRIPTION
     This program uses error correcting	protocol to receive files
     over a serial port	from a variety of programs running under
     TOS, PC-DOS, CP/M, Unix, and other operating systems.

     The first form of rz (Receive ZMODEM) receives files with
     the ZMODEM	batch protocol.	 If the	sending	program	does not
     support ZMODEM, rz	steps down to YMODEM protocol after 50
     seconds.  This delay can be eliminated by calling the pro-
     gram as rb	.

     When receiving with XMODEM	or YMODEM, Rz accepts either
     standard 128 byte sectors or 1024 byte sectors (YAM -k
     option).  The user	should determine when the longer block
     length actually improves throughput without causing prob-
     lems.

     If	extended file information (file	length,	etc.) is
     received, the file	length controls	the number of bytes writ-
     ten to the	output dataset (YMODEM only), and the modify time
     and file mode (iff	non zero) are set accordingly.

     If	no extended file information is	received, slashes in the
     pathname are changed to underscore, and any trailing period
     in	the pathname is	eliminated.  This conversion is	useful
     for files received	from CP/M systems.  With YMODEM, each
     file name is converted to lower case unless it contains one
     or	more lower case	letters.


     The second	form of	rz receives a single file with XMODEM
     protocol.	The user must supply the file name to both send-
     ing and receiving programs.

     If	rz is invoked with stdout and stderr to	different
     datasets, Verbose is set to 2, causing frame by frame pro-
     gress reports to stderr.  This may	be disabled with the q
     option.


     The meanings of the available options are:

     c	  Request 16 bit CRC.  XMODEM file transfers default to	8
	  bit checksum.	 YMODEM	and ZMODEM normally use	16 bit
	  CRC.
     p	  (ZMODEM) Protect: skip file if destination file exists.
     q	  Quiet	suppresses verbosity.
     t tim
	  Change timeout to tim	tenths of seconds.
     v	  Verbose, more v's give more verbose. Info is also

ZMODEM CAPABILITIES
     Rz	supports incoming ZMODEM binary	(-b), ASCII (-a), protect
     (-p), and append (-+) requests, and ZMODEM	command	execu-
     tion. Rz also supports incoming pathnames, and will recursively
     create all subdirectories as required. Rz preserve file mod
     times, and file protection. The translation of Unix protection
     bits to ST file attributes is based on the Unix owner (07XX)
     protection bits.  Presently, only read and write bits are considered.
     All received pathnames are considered to be rooted at the 
     current working directory. Any leading '/' from unix systems
     is discarded (ie. all incoming pathnames are considered unrooted,
     and are locally 'planted' at the current working directory).
     Ascii/Binary file modes are determined by examining the file
     extention on the incoming path name. If the extention is one
     of the following (case independent), then it is assumed to be
     a binary file, ascii other wise. The ascii translation of 
     '\n' to '\r\n' is done locally for ZMODEM (only).
     For X or Y modem the sender determines the file type.

	".PRG", ".TOS", ".TTP", ".ARC", ".ACC", ".IMG", ".RSC", ".O",
        ".OBJ", ".NEO", ".PIC", ".PI1", ".PI2", ".PI3", ".PQ1", ".PQ2",
        ".PQ3", ".BRD", ".ANI", ".STW", ".FNT", ".PRT", ".SNG", ".NEC",
        ".CNF", ".Z"  , ".DFN", ".GEM", ".EZD", ".LNK", ".SYM",
        ".PIX", ".X32", ".OUT", ".A",   ".CCC", ".CL",  ".CMD", ".COM",
        ".CRL", ".DAT", ".DIR", ".EXE", ".OVL", ".PAG", ".REL", ".SAV",
        ".SUB", ".SWP", ".SYS", ".TAR", ".UTL"

	  appended to logfile 'rzlog' .	More v's generate more output.


RZ/SZ(1)		      ST Programmer's Manual		    RZ/SZ(1)

NAME
     sz

SYNOPSIS
     sz	[-+defkLlNnopqtuvy]  file ...
     sz	-X [-kqtuv] file
     sz	[-oqtv] -c COMMAND
     sz	[-oqtv] -i COMMAND

DESCRIPTION
     Sz	uses the ZMODEM, YMODEM	or XMODEM error	correcting proto-
     col to send one or	more files over	a serial port to a
     variety of	programs running under PC-DOS, CP/M, Unix, VMS, TOS
     and other operating systems.


     The first form of sz sends	one or more files with ZMODEM or
     YMODEM batch protocol.  Normally, only the	file name part of
     the pathname is transmitted. Additional
     information about the file	is transmitted.	 If the	receiving
     program uses this information, the	transmitted file length
     controls the exact	number of bytes	written	to the output
     dataset, and the modify time and file mode	are set	accord-
     ingly.

     The second	form of	sz uses	the -X flag to send a single file
     with XMODEM or XMODEM-1k protocol.	 The user must supply the
     file name to both sending and receiving programs.


     The third form sends a single COMMAND to the receiver for
     execution.	 Sz exits with the COMMAND return value.


     The fourth	form sends a single COMMAND to the receiver for
     execution.	 Sz exits as soon as the receiver has correctly
     received the command, before it is	executed.


     In SZ Verbose is set to 2, causing frame by frame pro-
     gress reports to stderr.  This may	be disabled with the q
     option.

     The meanings of the available options are:

     +	  Instruct the receiver	to append transmitted data to an
	  existing file	(ZMODEM	only).
     c COMMAND
	  Send COMMAND to the receiver for execution, return with
	  COMMAND's exit status.
     d	  Change all instances of "." to "/" in	the transmitted
	  pathname.  Thus, C.omenB0000 (which is unacceptable to
	  MSDOS	or CP/M) is transmitted	as C/omenB0000.	 If the
	  resultant filename has more than 8 characters	in the
	  stem,	a "." is inserted to allow a total of eleven.
     E	  Escape only Ctrl-X control characters; normally XON,
	  XOFF,	CR-@-CR, and Ctrl-X are	escaped.
     e	  Escape all control characters; normally XON, XOFF, CR-
	  @-CR,	and Ctrl-X are escaped.
     f	  Send Full pathname.  Normally	directory prefixes are
	  stripped from	the transmitted	filename.
     i COMMAND
	  Send COMMAND to the receiver for execution, return
	  Immediately upon the receiving program's successful
	  recption of the command.
     k	  (XMODEM/YMODEM) Send files using 1024	byte blocks
	  rather than the default 128 byte blocks.  1024 byte
	  packets speed	file transfers at high bit rates.  (ZMO-
	  DEM streams the data for the best possible throughput.)
     L N  Use ZMODEM sub-packets of length N.  A larger	N (32 <=
	  N <= 1024) gives slightly higher throughput, a smaller
	  N speeds error recovery.  The	default	is 128 below 300
	  baud,	256 above 300 baud, or 1024 above 2400 baud.
     l N  Wait for the receiver	to acknowledge correct data every
	  N (32	<= N <=	1024) characters.  This	may be used to
	  avoid	network	overrun	when XOFF flow control is lack-
	  ing.
     n	  (ZMODEM) Send	each file if destination file does not
	  exist.  Overwrite destination	file if	source file is
	  newer	or longer than the destination file.
     N	  (ZMODEM) Send	each file if destination file does not
	  exist.  Overwrite destination	file if	source file has
	  different length or date.
     o	  (ZMODEM) Disable automatic selection of 32 bit CRC.
     p	  (ZMODEM) Protect existing destination	files by skipping
	  transfer if the destination file exists.
     q	  Quiet	suppresses verbosity.
     r	  Resume interrupted file transfer.  If	the source file
	  is longer than the destination file, the transfer com-
	  mences at the	offset in the source file that equals the
	  length of the	destination file.
     t tim
	  Change timeout to tim	tenths of seconds.
     u	  Unlink the file after	successful transmission.
     v	  Verbose causes a list	of file	names to be appended to
	  szlog .	More v's generate more output.
     X	  Send a single	file with XMODEM or XMODEM-1k protocol.
     y	  Instruct a ZMODEM receiving program to overwrite any
	  existing file	with the same name.


	SZ guesses the file mode by examining the filename extention as
	discusses under RZ above. SZ -f send full pathnames with '\'
	converted to '/'.

SEE ALSO
     ZMODEM.DOC, YMODEM.DOC, IMP(CP/M),	cu(1), Professional-YAM
     manual, sz(omen), usq(omen), undos(omen)

     Compile time options required for various operating systems
     are described in the source file.

NOTES
     The Unix "ulimit" parameter must be set high enough to per-
     mit large file transfers.

     The TTY input buffering on	some systems may not allow long
     blocks or streaming input,	especially at high baud	rates.
     The Pro-YAM zmodem	l numeric parameter may	be set to a value
     between 64	and 1024 to limit the burst length ("zmodem
     pl100").

BUGS
     Pathnames are restricted to 127 characters.  In XMODEM sin-
     gle file mode, the	pathname given on the command line is
     still processed as	described above.

FILES

     (rz|sz)log	stores debugging output	generated with -vvv[v]*
	        option.

OTHER COMMANDS
	The following command are available in the
	transfer shell:

	<regular-expression> ::= <file name> | <wild card> |
				 'quoted string'
	NB: A quoted string cannot contain imbedded single quotes. There
	    is no escape character available in a quoted string.

	rm,   remove files
		rm [-i] <regular expression>
		-i ::= interactive mode, you are prompted before
		       file(s) are removed.

	cp,   copy files
		cp <many files> directory
			copy all files into directory
			cp *.c d:\foo - copy all C files into foo 
				        directory on drive D:
		cp <file> <directory>
			copy file to directory\file.

		cp <file> <file>
			file to file copy
			cp file con: to get listing of file.

	ls,   list directory
		ls [wild card]
		ls without an argument will list all files in the
		current directory. If an argument is given, then
		only files macting the wild card will be listed.
			ls *.c - list all C files in current directory
			ls d:\foo - list all files in foo directory on D:
			ls d:\foo\*.c - list all C files in foo directory

	cd,   change working directory
		cd directory

	md,   make a directory
		md directory
	rd,   remove a directory
		rd directory
		Due to a Gemdos bug, you may have to say 'rd directory'
		twice to get rid of directory.
	pwd,  print  working directory
		prints the current working directory
	df,   check free space
		df [device]
		df without an argument will show free space on current drive.
		df with an argument will show free space on specified drive.

TERMCAP
	Termcap entries that may be used for the terminal emulator.

df|st|Atari ST 25 lines mode :\
	:bs:cd=6*\EJ:ce=6\EK:cl=6\EH\EJ:cm=6\EY%+ %+ :co#80:li#25:nd=\EC:\
	:pt:sr=6\EI:up=\EA:ku=\EA:kd=\EB:kr=\EC:kl=\ED:\
	:do=\EB:\
	:so=2\Ep:se=2\Eq:dl=6*\EM:al=6*\EL:am:

de|st-50|Atari ST 50 lines mode:\
	:bs:cd=6*\EJ:ce=6\EK:cl=6\EH\EJ:cm=6\EY%+ %+ :co#80:li#50:nd=\EC:\
	:pt:sr=6\EI:up=\EA:ku=\EA:kd=\EB:kr=\EC:kl=\ED:\
	:do=\EB:\
	:so=2\Ep:se=2\Eq:dl=6*\EM:al=6*\EL:am:

DISCLAIMER
	This code is in public domain, and you are encouraged
	to distribute it further. You may however not sell the
	code, or use it for any commercial gains. The code is
	provided as is, and we are not responsible for any
	omissions/errors, bugs, nor do we claim correctness or
	its fitness for any purpose.

	Please forward your comments and suggestions to

				Jwahar Bammi
			usenet: cwruecmp!bammi@decvax.UUCP
			csnet:  bammi@case.CSNET
			arpa:   bammi%case@csnet-relay.ARPA
			CompuServe: 71515,155

COMPILING
	The source provided with this distribution will compile
	with either ALCYON C V4.14 as distributed with the 
	Atari Development System, or with Mark Williams C Version 2.00
	(please note that the system will NOT compile with earlier
	 version of either compiler).
	To compile with Alcyon see the file `makefile'
	To compile with Mark Williams C see the file `makefile.mwc'

/* EOF */
